

<!DOCTYPE html>

<html lang="ja">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.3.24. io_flush &#8212; Groonga v10.1.1-31-g1e46ba6ドキュメント</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    <script src="../../_static/translations.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="索引" href="../../genindex.html" />
    <link rel="search" title="検索" href="../../search.html" />
    <link rel="next" title="7.3.25. load" href="load.html" />
    <link rel="prev" title="7.3.23. index_column_diff" href="index_column_diff.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">オープンソースのカラムストア機能付き全文検索エンジン</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../en/html/reference/commands/io_flush.html">English</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             accesskey="I">索引</a></li>
        <li class="right" >
          <a href="load.html" title="7.3.25. load"
             accesskey="N">次へ</a> |</li>
        <li class="right" >
          <a href="index_column_diff.html" title="7.3.23. index_column_diff"
             accesskey="P">前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../command.html" accesskey="U"><span class="section-number">7.3. </span>コマンド</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.3.24. </span><code class="docutils literal notranslate"><span class="pre">io_flush</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="io-flush">
<h1><span class="section-number">7.3.24. </span><code class="docutils literal notranslate"><span class="pre">io_flush</span></code><a class="headerlink" href="#io-flush" title="このヘッドラインへのパーマリンク">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.3.24.1. </span>概要<a class="headerlink" href="#summary" title="このヘッドラインへのパーマリンク">¶</a></h2>
<div class="versionadded">
<p><span class="versionmodified added">バージョン 5.0.5 で追加.</span></p>
</div>
<p><code class="docutils literal notranslate"><span class="pre">io_flush</span></code> はメモリー上のすべての変更を明示的にディスクに書き出します。通常、明示的に <code class="docutils literal notranslate"><span class="pre">io_flush</span></code> を使う必要はありません。なぜなら、OSが自動的に書き出してくれるからです。また、OSが書き出した方が効率的だからです。</p>
<p>いくつか明示的に <code class="docutils literal notranslate"><span class="pre">io_flush</span></code> を使う必要があるケースがあります。1つは、システムが不意にクラッシュすることがよくあるケースです。もう1つは、Groongaプロセスを通常の終了プロセスで終了できない可能性があるケースです。（通常の終了プロセスとは、例えば、 <a class="reference internal" href="shutdown.html"><span class="doc">shutdown</span></a> を使った終了プロセスです。）これらのケースでは、Groongaデータベースに変更を加えた後に <code class="docutils literal notranslate"><span class="pre">io_flush</span></code> を使うとよいです。以下はGroongaデータベースに変更を加えるコマンドのリストです。</p>
<blockquote>
<div><ul class="simple">
<li><p><a class="reference internal" href="column_create.html"><span class="doc">column_create</span></a></p></li>
<li><p><a class="reference internal" href="column_remove.html"><span class="doc">column_remove</span></a></p></li>
<li><p><a class="reference internal" href="column_rename.html"><span class="doc">column_rename</span></a></p></li>
<li><p><a class="reference internal" href="delete.html"><span class="doc">delete</span></a></p></li>
<li><p><a class="reference internal" href="load.html"><span class="doc">load</span></a></p></li>
<li><p><a class="reference internal" href="logical_table_remove.html"><span class="doc">logical_table_remove</span></a></p></li>
<li><p><a class="reference internal" href="object_remove.html"><span class="doc">object_remove</span></a></p></li>
<li><p><a class="reference internal" href="plugin_register.html"><span class="doc">plugin_register</span></a></p></li>
<li><p><a class="reference internal" href="plugin_unregister.html"><span class="doc">plugin_unregister</span></a></p></li>
<li><p><a class="reference internal" href="table_create.html"><span class="doc">table_create</span></a></p></li>
<li><p><a class="reference internal" href="table_remove.html"><span class="doc">table_remove</span></a></p></li>
<li><p><a class="reference internal" href="table_rename.html"><span class="doc">table_rename</span></a></p></li>
<li><p><a class="reference internal" href="truncate.html"><span class="doc">truncate</span></a></p></li>
</ul>
</div></blockquote>
<p>もし、 <a class="reference internal" href="select.html"><span class="doc">select</span></a> の <a class="reference internal" href="select.html#select-scorer"><span class="std std-ref">scorer</span></a> パラメーターをカラムの値を変更するために使っているなら、 <a class="reference internal" href="select.html"><span class="doc">select</span></a> もこのリストに入ります。</p>
<p><code class="docutils literal notranslate"><span class="pre">io_flush</span></code> は重い処理になる可能性があることに注意してください。もし、メモリー上に多くの変更があるなら、それらをディスクに書き出す処理は重い処理になります。</p>
<div class="versionadded">
<p><span class="versionmodified added">バージョン 8.0.8 で追加: </span><code class="docutils literal notranslate"><span class="pre">io_flush</span></code> はフラッシュ中はGroongaのデータベースをロックします。つまり、 <code class="docutils literal notranslate"><span class="pre">io_flush</span></code> 中は次のコマンドを実行できないということです。</p>
<blockquote>
<div><ul class="simple">
<li><p><a class="reference internal" href="column_create.html"><span class="doc">column_create</span></a></p></li>
<li><p><a class="reference internal" href="column_remove.html"><span class="doc">column_remove</span></a></p></li>
<li><p><a class="reference internal" href="column_rename.html"><span class="doc">column_rename</span></a></p></li>
<li><p><a class="reference internal" href="logical_table_remove.html"><span class="doc">logical_table_remove</span></a></p></li>
<li><p><a class="reference internal" href="object_remove.html"><span class="doc">object_remove</span></a></p></li>
<li><p><a class="reference internal" href="plugin_register.html"><span class="doc">plugin_register</span></a></p></li>
<li><p><a class="reference internal" href="plugin_unregister.html"><span class="doc">plugin_unregister</span></a></p></li>
<li><p><a class="reference internal" href="table_create.html"><span class="doc">table_create</span></a></p></li>
<li><p><a class="reference internal" href="table_remove.html"><span class="doc">table_remove</span></a></p></li>
<li><p><a class="reference internal" href="table_rename.html"><span class="doc">table_rename</span></a></p></li>
</ul>
</div></blockquote>
</div>
</div>
<div class="section" id="syntax">
<h2><span class="section-number">7.3.24.2. </span>構文<a class="headerlink" href="#syntax" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>このコマンドの引数は3つです。</p>
<p>すべての引数は省略可能です:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>io_flush [target_name=null]
         [recursive=yes]
         [only_opened=no]
</pre></div>
</div>
<div class="versionadded">
<p><span class="versionmodified added">バージョン 7.0.4 で追加: </span><a class="reference internal" href="#io-flush-only-opened"><span class="std std-ref">only_opened</span></a> が追加されました。</p>
</div>
<div class="versionadded">
<p><span class="versionmodified added">バージョン 9.0.2 で追加: </span><code class="docutils literal notranslate"><span class="pre">--recursive</span> <span class="pre">dependent</span></code> が追加されました。9.0.2以降で対象のオブジェクトを書き出すのにおすすめの方法です。オプションの詳細は <a class="reference internal" href="#io-flush-recursive"><span class="std std-ref">recursive</span></a> を参照してください。</p>
</div>
</div>
<div class="section" id="usage">
<h2><span class="section-number">7.3.24.3. </span>使い方<a class="headerlink" href="#usage" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>引数無しで実行するとメモリー上のすべての変更をディスクに書き出すことができます。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>io_flush
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p>もし変更点を把握しているなら、書き出し対象を狭めることができます。以下はGroonga 9.0.2以降向けのコマンドと書き出し対象の対応表です。</p>
<div class="admonition note">
<p class="admonition-title">注釈</p>
<p>Groonga が9.0.1以前の場合( <code class="docutils literal notranslate"><span class="pre">--recursive</span> <span class="pre">dependent</span></code> が使えないので)関連するオブジェクトを明示的に書き出す必要があります。それ以降はオブジェクトの書き出し忘れをしないようにするのには <code class="docutils literal notranslate"><span class="pre">--recursive</span> <span class="pre">dependent</span></code> を使うのがおすすめです。</p>
</div>
<table class="docutils align-default">
<colgroup>
<col style="width: 33%" />
<col style="width: 33%" />
<col style="width: 33%" />
</colgroup>
<thead>
<tr class="row-odd"><th class="head"><p>コマンド</p></th>
<th class="head"><p>書き出し対象</p></th>
<th class="head"><p><code class="docutils literal notranslate"><span class="pre">io_flush</span></code> の引数</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p><a class="reference internal" href="load.html"><span class="doc">load</span></a> と <a class="reference internal" href="delete.html"><span class="doc">delete</span></a></p></td>
<td><p>テーブルとそのテーブルのカラム。</p>
<p>カラムの中に参照カラムがある場合、参照されているテーブルも書き出し対象になる。</p>
<p>インデックスが張られているカラムがある場合、対応するインデックスカラムとそのインデックスカラムのテーブルも書き出し対象になる。</p>
</td>
<td><p>対象となるテーブルとそのカラム、参照先のテーブル、インデックスが張られているカラムがある場合、対応するインデックスカラムとそのインデックスカラムのテーブルを書き出すのに <code class="docutils literal notranslate"><span class="pre">--recursive</span> <span class="pre">dependent</span></code> を使います。</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>io_flush --target_name TABLE_NAME --recursive dependent
</pre></div>
</div>
</td>
</tr>
<tr class="row-odd"><td><p><a class="reference internal" href="truncate.html"><span class="doc">truncate</span></a></p></td>
<td><p>テーブルとそのテーブルのカラム。</p>
<p>カラムの中に参照カラムがある場合、参照されているテーブルも書き出し対象になる。</p>
<p>インデックスが張られているカラムがある場合、対応するインデックスカラムとそのインデックスカラムのテーブルも書き出し対象になる。</p>
<p>データベースも書き出し対象。</p>
</td>
<td><p>対象となるテーブルとそのカラム、参照先のテーブル、インデックスが張られているカラムがある場合、対応するインデックスカラムとそのインデックスカラムのテーブルを書き出すのに <code class="docutils literal notranslate"><span class="pre">--recursive</span> <span class="pre">dependent</span></code> を使います。</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>io_flush --target_name TABLE_NAME --recursive dependent
</pre></div>
</div>
</td>
</tr>
<tr class="row-even"><td><p><a class="reference internal" href="table_create.html"><span class="doc">table_create</span></a></p></td>
<td><p>処理対象のテーブルとデータベース。</p></td>
<td><p>テーブル:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>io_flush --target_name TABLE_NAME --recursive dependent
</pre></div>
</div>
</td>
</tr>
<tr class="row-odd"><td><p><a class="reference internal" href="table_remove.html"><span class="doc">table_remove</span></a> と <a class="reference internal" href="table_rename.html"><span class="doc">table_rename</span></a> と <a class="reference internal" href="logical_table_remove.html"><span class="doc">logical_table_remove</span></a></p></td>
<td><p>データベース。</p></td>
<td><p>データベース:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>io_flush --recursive no
</pre></div>
</div>
</td>
</tr>
<tr class="row-even"><td><p><a class="reference internal" href="column_create.html"><span class="doc">column_create</span></a></p></td>
<td><p>処理対象のカラムとデータベース。</p></td>
<td><p>テーブル:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>io_flush --target_name TABLE_NAME.COLUMN_NAME --recursive dependent
</pre></div>
</div>
</td>
</tr>
<tr class="row-odd"><td><p><a class="reference internal" href="column_remove.html"><span class="doc">column_remove</span></a> と <a class="reference internal" href="column_rename.html"><span class="doc">column_rename</span></a></p></td>
<td><p>データベース。</p></td>
<td><p>データベース:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>io_flush --recursive no
</pre></div>
</div>
</td>
</tr>
<tr class="row-even"><td><p><a class="reference internal" href="plugin_register.html"><span class="doc">plugin_register</span></a> と <a class="reference internal" href="plugin_unregister.html"><span class="doc">plugin_unregister</span></a></p></td>
<td><p>データベース。</p></td>
<td><p>データベース:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>io_flush --recursive no
</pre></div>
</div>
</td>
</tr>
</tbody>
</table>
<p>もしGroongaが9.0.1以前なら( <code class="docutils literal notranslate"><span class="pre">--recursive</span> <span class="pre">dependent</span></code> が使えないので) 明示的にオブジェクトを書き出す必要があります。以下はGroonga 9.0.1以前向けのコマンドと書き出し対象の対応表です。</p>
<table class="docutils align-default">
<colgroup>
<col style="width: 33%" />
<col style="width: 33%" />
<col style="width: 33%" />
</colgroup>
<thead>
<tr class="row-odd"><th class="head"><p>コマンド</p></th>
<th class="head"><p>書き出し対象</p></th>
<th class="head"><p><code class="docutils literal notranslate"><span class="pre">io_flush</span></code> の引数</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p><a class="reference internal" href="load.html"><span class="doc">load</span></a> と <a class="reference internal" href="delete.html"><span class="doc">delete</span></a></p></td>
<td><p>テーブルとそのテーブルのカラム。</p>
<p>カラムの中に参照カラムがある場合、参照されているテーブルも書き出し対象になる。</p>
<p>インデックスが張られているカラムがある場合、対応するインデックスカラムとそのインデックスカラムのテーブルも書き出し対象になる。</p>
</td>
<td><p>テーブルとそのテーブルのカラム:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>io_flush --target_name TABLE_NAME
</pre></div>
</div>
<p>参照されているテーブル:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>io_flush --target_name REFERENCED_TABLE_NAME --recursive no
</pre></div>
</div>
<p>インデックスカラムのテーブル:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>io_flush --target_name TABLE_NAME_OF_INDEX_COLUMN --recursive no
</pre></div>
</div>
<p>インデックスカラム:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>io_flush --target_name TABLE_NAME_OF_INDEX_COLUMN.INDEX_COLUMN
</pre></div>
</div>
</td>
</tr>
<tr class="row-odd"><td><p><a class="reference internal" href="truncate.html"><span class="doc">truncate</span></a></p></td>
<td><p>テーブルとそのテーブルのカラム。</p>
<p>カラムの中に参照カラムがある場合、参照されているテーブルも書き出し対象になる。</p>
<p>インデックスが張られているカラムがある場合、対応するインデックスカラムとそのインデックスカラムのテーブルも書き出し対象になる。</p>
<p>データベースも書き出し対象。</p>
</td>
<td><p>テーブルとそのテーブルのカラム:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>io_flush --target_name TABLE_NAME
</pre></div>
</div>
<p>参照されているテーブル:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>io_flush --target_name REFERENCED_TABLE_NAME --recursive no
</pre></div>
</div>
<p>インデックスカラムのテーブル:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>io_flush --target_name TABLE_NAME_OF_INDEX_COLUMN --recursive no
</pre></div>
</div>
<p>インデックスカラム:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>io_flush --target_name TABLE_NAME_OF_INDEX_COLUMN.INDEX_COLUMN
</pre></div>
</div>
<p>データベース:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>io_flush --recursive no
</pre></div>
</div>
</td>
</tr>
<tr class="row-even"><td><p><a class="reference internal" href="table_create.html"><span class="doc">table_create</span></a></p></td>
<td><p>処理対象のテーブルとデータベース。</p></td>
<td><p>テーブル:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>io_flush --target_name TABLE_NAME
</pre></div>
</div>
<p>データベース:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>io_flush --recursive no
</pre></div>
</div>
</td>
</tr>
<tr class="row-odd"><td><p><a class="reference internal" href="table_remove.html"><span class="doc">table_remove</span></a> と <a class="reference internal" href="table_rename.html"><span class="doc">table_rename</span></a> と <a class="reference internal" href="logical_table_remove.html"><span class="doc">logical_table_remove</span></a></p></td>
<td><p>データベース。</p></td>
<td><p>データベース:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>io_flush --recursive no
</pre></div>
</div>
</td>
</tr>
<tr class="row-even"><td><p><a class="reference internal" href="column_create.html"><span class="doc">column_create</span></a></p></td>
<td><p>処理対象のカラムとデータベース。</p></td>
<td><p>テーブル:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>io_flush --target_name TABLE_NAME.COLUMN_NAME
</pre></div>
</div>
<p>データベース:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>io_flush --recursive no
</pre></div>
</div>
</td>
</tr>
<tr class="row-odd"><td><p><a class="reference internal" href="column_remove.html"><span class="doc">column_remove</span></a> と <a class="reference internal" href="column_rename.html"><span class="doc">column_rename</span></a></p></td>
<td><p>データベース。</p></td>
<td><p>データベース:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>io_flush --recursive no
</pre></div>
</div>
</td>
</tr>
<tr class="row-even"><td><p><a class="reference internal" href="plugin_register.html"><span class="doc">plugin_register</span></a> と <a class="reference internal" href="plugin_unregister.html"><span class="doc">plugin_unregister</span></a></p></td>
<td><p>データベース。</p></td>
<td><p>データベース:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>io_flush --recursive no
</pre></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="parameters">
<h2><span class="section-number">7.3.24.4. </span>引数<a class="headerlink" href="#parameters" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>このセクションではすべての引数について説明します。</p>
<div class="section" id="required-parameters">
<h3><span class="section-number">7.3.24.4.1. </span>必須引数<a class="headerlink" href="#required-parameters" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p>必須の引数はありません。</p>
</div>
<div class="section" id="optional-parameters">
<h3><span class="section-number">7.3.24.4.2. </span>省略可能引数<a class="headerlink" href="#optional-parameters" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p>いくつか省略可能な引数があります。</p>
<div class="section" id="target-name">
<span id="io-flush-target-name"></span><h4><span class="section-number">7.3.24.4.2.1. </span><code class="docutils literal notranslate"><span class="pre">target_name</span></code><a class="headerlink" href="#target-name" title="このヘッドラインへのパーマリンク">¶</a></h4>
<p>対象オブジェクトの名前を指定します。対象オブジェクトはデータベース、テーブル、カラムのどれかです。</p>
<p>このパラメーターを省略すると、データベースが対象オブジェクトになります。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>io_flush
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p>テーブル名を指定すると、そのテーブルが対象オブジェクトになります。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>table_create Users TABLE_HASH_KEY ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
io_flush --target_name Users
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p>カラム名を指定すると、そのカラムが対象オブジェクトになります。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>column_create Users age COLUMN_SCALAR UInt8
# [[0, 1337566253.89858, 0.000355720520019531], true]
io_flush --target_name Users.age
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
</div>
<div class="section" id="recursive">
<span id="io-flush-recursive"></span><h4><span class="section-number">7.3.24.4.2.2. </span><code class="docutils literal notranslate"><span class="pre">recursive</span></code><a class="headerlink" href="#recursive" title="このヘッドラインへのパーマリンク">¶</a></h4>
<p>書き出し対象オブジェクトの子オブジェクトも対象にするかどうかを指定します。</p>
<p>データベースの子オブジェクトはすべてのテーブルとすべてのカラムです。</p>
<p>テーブルの子オブジェクトはそのテーブルのすべてのカラムです。</p>
<p>カラムの子オブジェクトはありません。</p>
<p><a class="reference internal" href="#io-flush-only-opened"><span class="std std-ref">only_opened</span></a> に <code class="docutils literal notranslate"><span class="pre">yes</span></code> を指定すると <code class="docutils literal notranslate"><span class="pre">recursive</span></code> は無視されます。</p>
<p><code class="docutils literal notranslate"><span class="pre">recursive</span></code> の値は <code class="docutils literal notranslate"><span class="pre">yes</span></code> または <code class="docutils literal notranslate"><span class="pre">no</span></code> もしくは <code class="docutils literal notranslate"><span class="pre">dependent</span></code> でなければいけません。 <code class="docutils literal notranslate"><span class="pre">yes</span></code> は指定した対象オブジェクトとその子オブジェクトすべてを対象オブジェクトにするという意味です。 <code class="docutils literal notranslate"><span class="pre">no</span></code> は指定した対象オブジェクトのみを対象オブジェクトにするという意味です。<code class="docutils literal notranslate"><span class="pre">dependent</span></code> は指定した対象オブジェクトとその子オブジェクトすべて、参照先のテーブル、インデックスが張られているカラムがある場合、対応するインデックスカラムとそのインデックスカラムのテーブルを対象オブジェクトにするという意味です。</p>
<p>次の <code class="docutils literal notranslate"><span class="pre">io_flush</span></code> はデータベースとすべてのテーブルとすべてのカラムのすべての変更を書き出します。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>io_flush --recursive yes
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p>次の <code class="docutils literal notranslate"><span class="pre">io_flush</span></code> はデータベースの変更だけを書き出します。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>io_flush --recursive no
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p>他の値（つまり、 <code class="docutils literal notranslate"><span class="pre">yes</span></code> でも <code class="docutils literal notranslate"><span class="pre">no</span></code> でもない値）を指定した場合、または <code class="docutils literal notranslate"><span class="pre">recursive</span></code> パラメーターを指定しない場合は <code class="docutils literal notranslate"><span class="pre">yes</span></code> が使われます。</p>
<p><code class="docutils literal notranslate"><span class="pre">recursive</span></code> 引数の値が不正なので、次のケースでは <code class="docutils literal notranslate"><span class="pre">yes</span></code> が使われます。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>io_flush --recursive invalid
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">recursive</span></code> パラメーターが指定されていないので、次のケースでは <code class="docutils literal notranslate"><span class="pre">yes</span></code> が使われます。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>io_flush
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p>9.0.2から <code class="docutils literal notranslate"><span class="pre">--recursive</span> <span class="pre">dependent</span></code> が追加され、書き出し対象とその子オブジェクトだけでなく、関連したオブジェクトも書き出し対象にするようになりました。関連するオブジェクトは次のとおり:</p>
<ul class="simple">
<li><p>参照されているテーブル</p></li>
<li><p>関連するインデックスカラム(対象の <code class="docutils literal notranslate"><span class="pre">TABLE_NAME</span></code> にソースカラムがある)</p></li>
<li><p>関連するインデックスカラムのテーブル(対象の <code class="docutils literal notranslate"><span class="pre">TABLE_NAME</span></code> にソースカラムがある)</p></li>
</ul>
<p>関連するオブジェクトのフラッシュ漏れをなくすのに便利です。</p>
<p>例えば、 <code class="docutils literal notranslate"><span class="pre">--recursive</span> <span class="pre">dependent</span></code> が <code class="docutils literal notranslate"><span class="pre">TABLE_NAME</span></code> に指定されていると、このオプションは以下と同等のコマンドを内部で実行します。</p>
<ul>
<li><p>テーブルとそのテーブルのカラムをフラッシュ:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>io_flush --target_name TABLE_NAME --recursive yes
</pre></div>
</div>
</li>
<li><p>参照されているテーブルをフラッシュ:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>io_flush --target_name REFERENCED_TABLE_NAME --recursive no
</pre></div>
</div>
</li>
<li><p>関連するインデックスカラムをフラッシュ(対象の <code class="docutils literal notranslate"><span class="pre">TABLE_NAME</span></code> にソースカラムがある):</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>io_flush --target_name TABLE_NAME_OF_INDEX_COLUMN.INDEX_COLUMN
</pre></div>
</div>
</li>
<li><p>関連するインデックスカラムのテーブルをフラッシュ(対象の <code class="docutils literal notranslate"><span class="pre">TABLE_NAME</span></code> にソースカラムがある):</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>io_flush --target_name TABLE_NAME_OF_INDEX_COLUMN --recursive no
</pre></div>
</div>
</li>
</ul>
<p>すべての対象となるオブジェクトが正しくフラッシュされたかを確認するにはクエリーログをチェックします:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>&gt; io_flush --recursive &quot;dependent&quot; --target_name &quot;Users&quot;
:000000000000000 flush[Users]
:000000000000000 flush[Terms]
:000000000000000 flush[Terms.users_name]
:000000000000000 flush[Users.name]
:000000000000000 flush[(anonymous:table:dat_key)]
:000000000000000 flush[(anonymous:column:var_size)]
:000000000000000 flush[(anonymous:table:hash_key)]
:000000000000000 flush[(anonymous:column:var_size)]
:000000000000000 flush[(DB)]
&lt;000000000000000 rc=0
</pre></div>
</div>
<p>上記の例では、 指定した <code class="docutils literal notranslate"><span class="pre">Users</span></code> テーブルだけでなく、関連する語彙表の <code class="docutils literal notranslate"><span class="pre">Terms</span></code> テーブルとインデックスカラム <code class="docutils literal notranslate"><span class="pre">Terms.users_name</span></code> カラム( <code class="docutils literal notranslate"><span class="pre">Users.name</span></code> がソースカラム)もフラッシュされています。</p>
<p><code class="docutils literal notranslate"><span class="pre">flush[(anonymous:...)]</span></code> と <code class="docutils literal notranslate"><span class="pre">flush[(DB)]</span></code> はGroongaの内部のオブジェクトがフラッシュされたことを意味します。</p>
<table class="docutils align-default">
<colgroup>
<col style="width: 50%" />
<col style="width: 50%" />
</colgroup>
<thead>
<tr class="row-odd"><th class="head"><p>ログ</p></th>
<th class="head"><p>説明</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p><code class="docutils literal notranslate"><span class="pre">flush[(anonymous:table:dat_key)]</span></code></p></td>
<td><p>DB内部のオブジェクト名がフラッシュされます。もし <code class="docutils literal notranslate"><span class="pre">GRN_DB_KEY=pat</span></code> が指定されていると <code class="docutils literal notranslate"><span class="pre">TABLE_PAT_KEY</span></code> が使われます。</p></td>
</tr>
<tr class="row-odd"><td><p><code class="docutils literal notranslate"><span class="pre">flush[(anonymous:column:var_size)]</span></code> (1番目に記録されている <code class="docutils literal notranslate"><span class="pre">(anonymous:column:var_size)</span></code> オブジェクト)</p></td>
<td><p>内部のオブジェクトのメタデータ(組込の型だったり、トークンフィルターなど)がフラッシュされます。</p>
<p>可変長のカラムで、内部で使っているオブジェクトのメタデータを保持しています。</p>
</td>
</tr>
<tr class="row-even"><td><p><code class="docutils literal notranslate"><span class="pre">flush[(anonymous:table:hash_key)]</span></code></p></td>
<td><p>設定情報のオブジェクト( <code class="docutils literal notranslate"><span class="pre">config_set</span></code> で設定される)がフラッシュされます。</p></td>
</tr>
<tr class="row-odd"><td><p><code class="docutils literal notranslate"><span class="pre">flush[(anonymous:column:var_size)]</span></code> (2番目に記録されている <code class="docutils literal notranslate"><span class="pre">(anonymous:column:var_size)</span></code> オブジェクト)</p></td>
<td><p>内部のオブジェクトのメタデータ(内部で使っているオブジェクトのオプション。トークナイザーのオプションなど)がフラッシュされます。</p>
<p>可変長のカラムで、内部で使っているオブジェクトのメタデータを保持しています。</p>
</td>
</tr>
<tr class="row-even"><td><p><code class="docutils literal notranslate"><span class="pre">flush[(DB)]</span></code></p></td>
<td><p>DBの変更( <code class="docutils literal notranslate"><span class="pre">io_flush</span></code> を実行中にロックを獲得している) がフラッシュされます。</p></td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="only-opened">
<span id="io-flush-only-opened"></span><h4><span class="section-number">7.3.24.4.2.3. </span><code class="docutils literal notranslate"><span class="pre">only_opened</span></code><a class="headerlink" href="#only-opened" title="このヘッドラインへのパーマリンク">¶</a></h4>
<div class="versionadded">
<p><span class="versionmodified added">バージョン 7.0.4 で追加.</span></p>
</div>
<p>すでに開かれているオブジェクトだけフラッシュするかどうかを指定します。</p>
<p>対象のデータベースを変更するプロセスが1つだけの場合、 <code class="docutils literal notranslate"><span class="pre">only_opened</span></code> に <code class="docutils literal notranslate"><span class="pre">yes</span></code> を指定することでフラッシュの性能が改善する可能性があります。これは、不要なフラッシュを省略するからです。</p>
<p><a class="reference internal" href="#io-flush-target-name"><span class="std std-ref">target_name</span></a> と <code class="docutils literal notranslate"><span class="pre">only_opened</span></code> オプションを一緒に指定することはできません。もし、 <a class="reference internal" href="#io-flush-target-name"><span class="std std-ref">target_name</span></a> を指定した場合は <code class="docutils literal notranslate"><span class="pre">only_opened</span></code> は無視されます。</p>
<p><code class="docutils literal notranslate"><span class="pre">only_opened</span></code> に <code class="docutils literal notranslate"><span class="pre">yes</span></code> を指定した場合、 <a class="reference internal" href="#io-flush-recursive"><span class="std std-ref">recursive</span></a> は無視されます。</p>
<p><code class="docutils literal notranslate"><span class="pre">only_opened</span></code> の値は <code class="docutils literal notranslate"><span class="pre">yes</span></code> または <code class="docutils literal notranslate"><span class="pre">no</span></code> でなければいけません。 <code class="docutils literal notranslate"><span class="pre">yes</span></code> の場合はすでに開かれているオブジェクトだけフラッシュします。 <code class="docutils literal notranslate"><span class="pre">no</span></code> の場合は開いているかどうかに関わらず、対象のオブジェクトをフラッシュします。</p>
<p>次の <code class="docutils literal notranslate"><span class="pre">io_flush</span></code> はデータベースとすべてのテーブルとすべてのカラムのすべての変更を書き出します。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>io_flush --only_opened yes
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
</div>
</div>
</div>
<div class="section" id="return-value">
<h2><span class="section-number">7.3.24.5. </span>戻り値<a class="headerlink" href="#return-value" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>このコマンドが成功したときは以下のようにボディは <code class="docutils literal notranslate"><span class="pre">true</span></code> になります:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>[HEADER, true]
</pre></div>
</div>
<p>このコマンドが失敗すると、 <code class="docutils literal notranslate"><span class="pre">HEADER</span></code> にエラーの詳細が含まれます。</p>
<p><code class="docutils literal notranslate"><span class="pre">HEADER</span></code> については <a class="reference internal" href="../command/output_format.html"><span class="doc">出力形式</span></a> を参照してください。</p>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">目次</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.3.24. <code class="docutils literal notranslate"><span class="pre">io_flush</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.3.24.1. 概要</a></li>
<li><a class="reference internal" href="#syntax">7.3.24.2. 構文</a></li>
<li><a class="reference internal" href="#usage">7.3.24.3. 使い方</a></li>
<li><a class="reference internal" href="#parameters">7.3.24.4. 引数</a><ul>
<li><a class="reference internal" href="#required-parameters">7.3.24.4.1. 必須引数</a></li>
<li><a class="reference internal" href="#optional-parameters">7.3.24.4.2. 省略可能引数</a><ul>
<li><a class="reference internal" href="#target-name">7.3.24.4.2.1. <code class="docutils literal notranslate"><span class="pre">target_name</span></code></a></li>
<li><a class="reference internal" href="#recursive">7.3.24.4.2.2. <code class="docutils literal notranslate"><span class="pre">recursive</span></code></a></li>
<li><a class="reference internal" href="#only-opened">7.3.24.4.2.3. <code class="docutils literal notranslate"><span class="pre">only_opened</span></code></a></li>
</ul>
</li>
</ul>
</li>
<li><a class="reference internal" href="#return-value">7.3.24.5. 戻り値</a></li>
</ul>
</li>
</ul>

  <h4>前のトピックへ</h4>
  <p class="topless"><a href="index_column_diff.html"
                        title="前の章へ"><span class="section-number">7.3.23. </span><code class="docutils literal notranslate"><span class="pre">index_column_diff</span></code></a></p>
  <h4>次のトピックへ</h4>
  <p class="topless"><a href="load.html"
                        title="次の章へ"><span class="section-number">7.3.25. </span><code class="docutils literal notranslate"><span class="pre">load</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">クイック検索</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="検索" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             >索引</a></li>
        <li class="right" >
          <a href="load.html" title="7.3.25. load"
             >次へ</a> |</li>
        <li class="right" >
          <a href="index_column_diff.html" title="7.3.23. index_column_diff"
             >前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../command.html" ><span class="section-number">7.3. </span>コマンド</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.3.24. </span><code class="docutils literal notranslate"><span class="pre">io_flush</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>